// Copyright (C) 2003 Delyan Kalchev
// It's free so do whatever you want!

#include <windows.h>
#include <stdlib.h>
#include <time.h>

#define FIELD_WIDTH 12
#define FIELD_HEIGHT 22
#define RECTCOLOR RGB(0,0,255)
#define RECTBORDER RGB(255,255,0)
#define LEFT TRUE
#define RIGHT FALSE
#define DoLeftM(NewMatrix, OldMatrix, x, y) (NewMatrix[y][3-x]=OldMatrix[x][y])
#define DoRightM(NewMatrix, OldMatrix, x, y) (NewMatrix[3-y][x]=OldMatrix[x][y])
#define IsZeroRowM(Matrix, y) (!Matrix[0][y]&&!Matrix[1][y]&&!Matrix[2][y]&&!Matrix[3][y])
#define IsZeroColM(Matrix, x) (!Matrix[x][0]&&!Matrix[x][1]&&!Matrix[x][2]&&!Matrix[x][3])
#define IsZeroM(Matrix) (IsZeroRowM(Matrix,0)&&IsZeroRowM(Matrix,1)&&IsZeroRowM(Matrix,2)&&IsZeroRowM(Matrix,3))

typedef BOOL Block;

HINSTANCE hinst;
HWND hwndMain;

Block Field[FIELD_WIDTH][FIELD_HEIGHT];
Block Matrix[4][4]; //Matrix[X][Y]
short X, Y;
HBRUSH InBrush;
HPEN Border;
short m_side;
Block OldField[FIELD_WIDTH][FIELD_HEIGHT];
UINT nIDEv;
BOOL Paused;
RECT rect;

void CopyRowM(Block [4][4], short, Block [4][4], short);
void CopyColM(Block [4][4], short, Block [4][4], short);
void Copy();
void NormalizeM(Block [4][4]);
void DeleteRowsM(Block [4][4], short, short);
void DeleteColsM(Block [4][4], short, short);
short WidthM();
void DrawBlock(short, short, HDC);
void DrawM(HDC);
void DelRows();
BOOL OverlapM(Block [4][4], short, short);
void DoDie();
void Incorp(Block [FIELD_WIDTH][FIELD_HEIGHT]);
void DoRect(RECT *, short, short);
void ReSetM();
void Full();
void ReDraw();
void SetBitsM(Block, Block, Block, Block,
	 		  Block, Block, Block, Block,
			  Block, Block, Block, Block,
			  Block, Block, Block, Block);
void SetBitsM(const Block [4][4]);
void RotateM(BOOL, BOOL);
void New();
void Fall();
void MoveLeft();
void MoveRight();
void MoveDown();
void Draw(HDC);
VOID CALLBACK TimerProc(HWND, UINT, UINT, DWORD);

void CopyRowM(Block ToMatrix[4][4], short y0, Block FromMatrix[4][4], short y)
{	
	ToMatrix[0][y0]=FromMatrix[0][y];
	ToMatrix[1][y0]=FromMatrix[1][y];
	ToMatrix[2][y0]=FromMatrix[2][y];
	ToMatrix[3][y0]=FromMatrix[3][y];
}

void CopyColM(Block ToMatrix[4][4], short x0, Block FromMatrix[4][4], short x)
{
	ToMatrix[x0][0]=FromMatrix[x][0];
	ToMatrix[x0][1]=FromMatrix[x][1];
	ToMatrix[x0][2]=FromMatrix[x][2];
	ToMatrix[x0][3]=FromMatrix[x][3];
}

void SetBitsM(Block a=0, Block b=0, Block c=0, Block d=0,
		   	  Block e=0, Block f=0, Block g=0, Block h=0,
			  Block i=0, Block j=0, Block k=0, Block l=0,
			  Block m=0, Block n=0, Block o=0, Block p=0)
{
	Matrix[0][0] = a; Matrix[1][0] = b; Matrix[2][0] = c; Matrix[3][0] = d;
	Matrix[0][1] = e; Matrix[1][1] = f; Matrix[2][1] = g; Matrix[3][1] = h;
	Matrix[0][2] = i; Matrix[1][2] = j; Matrix[2][2] = k; Matrix[3][2] = l;
	Matrix[0][3] = m; Matrix[1][3] = n; Matrix[2][3] = o; Matrix[3][3] = p;
}

void SetBitsM(const Block sFigMatrix[4][4])
{
	Matrix[0][0] = sFigMatrix[0][0]; Matrix[1][0] = sFigMatrix[1][0]; Matrix[2][0] = sFigMatrix[2][0]; Matrix[3][0] = sFigMatrix[3][0];
	Matrix[0][1] = sFigMatrix[0][1]; Matrix[1][1] = sFigMatrix[1][1]; Matrix[2][1] = sFigMatrix[2][1]; Matrix[3][1] = sFigMatrix[3][1];
	Matrix[0][2] = sFigMatrix[0][2]; Matrix[1][2] = sFigMatrix[1][2]; Matrix[2][2] = sFigMatrix[2][2]; Matrix[3][2] = sFigMatrix[3][2];
	Matrix[0][3] = sFigMatrix[0][3]; Matrix[1][3] = sFigMatrix[1][3]; Matrix[2][3] = sFigMatrix[2][3]; Matrix[3][3] = sFigMatrix[3][3];
}

void NormalizeM(Block NewMatrix[4][4])
{
	short i=0;
	while (IsZeroRowM(NewMatrix, i) && i++<4);
	if (i<5 && i>=1) DeleteRowsM(NewMatrix, 0, i-1);
	i=0;
	while (IsZeroColM(NewMatrix, i) && i++<4);
	if (i<5 && i>=1) DeleteColsM(NewMatrix, 0, i-1);
}

void DeleteRowsM(Block NewMatriX[4][4], short from, short to)
{
	if ((from > to) || (to-from>3)) return;
	Block NewMatrix[4][4] = { 0, 0, 0, 0,
							  0, 0, 0, 0,
							  0, 0, 0, 0,
							  0, 0, 0, 0 };
	short y=0;
	const short dif=(to-from)+1;
	for (; y < from; y++) CopyRowM(NewMatrix, y, NewMatriX, y);
	for (y=to+1; y < 4; y++) CopyRowM(NewMatrix, y-dif, NewMatriX, y);
	CopyColM(NewMatriX, 0, NewMatrix, 0);
	CopyColM(NewMatriX, 1, NewMatrix, 1);
	CopyColM(NewMatriX, 2, NewMatrix, 2);
	CopyColM(NewMatriX, 3, NewMatrix, 3);
}

void DeleteColsM(Block NewMatriX[4][4], short from, short to)
{
	if ((from > to) || (to-from>3)) return;
	Block NewMatrix[4][4] = { 0, 0, 0, 0,
							  0, 0, 0, 0,
							  0, 0, 0, 0,
							  0, 0, 0, 0 };
	short x=0;
	const short dif=(to-from)+1;
	for (; x < from; x++) CopyColM(NewMatrix, x, NewMatriX, x);
	for (x=to+1; x < 4; x++) CopyColM(NewMatrix, x-dif, NewMatriX, x);
	CopyColM(NewMatriX, 0, NewMatrix, 0);
	CopyColM(NewMatriX, 1, NewMatrix, 1);
	CopyColM(NewMatriX, 2, NewMatrix, 2);
	CopyColM(NewMatriX, 3, NewMatrix, 3);
}

void RotateM(BOOL z=LEFT, BOOL rdraw=TRUE)
{
	if (rdraw) Copy();
	Block NewMatrix[4][4];
	short x, y;
	for (y=0; y<4; y++) {
		for (x=0; x<4; x++) {
			z==LEFT?DoLeftM(NewMatrix, Matrix, x, y) :
					DoRightM(NewMatrix, Matrix, x, y);
		}
	}
	NormalizeM(NewMatrix);
	if (OverlapM(NewMatrix, X, Y) && rdraw) return;
	SetBitsM(NewMatrix);
	if (rdraw) ReDraw();
}

void ReSetM()
{
	short i=rand()%4;
	switch (rand()%7) {
	case 0:
		SetBitsM(1, 1, 1, 1,
				 0, 0, 0, 0,
				 0, 0, 0, 0,
				 0, 0, 0, 0);
		break;
	case 1:
		SetBitsM(1, 1, 0, 0,
				 1, 1, 0, 0,
				 0, 0, 0, 0,
				 0, 0, 0, 0);
		break;
	case 2:
		SetBitsM(0, 1, 0, 0,
				 1, 1, 1, 0,
				 0, 0, 0, 0,
				 0, 0, 0, 0);
		break;
	case 3:
		SetBitsM(1, 1, 0, 0,
				 0, 1, 1, 0,
				 0, 0, 0, 0,
				 0, 0, 0, 0);
		break;
	case 4:
		SetBitsM(0, 1, 1, 0,
				 1, 1, 0, 0,
				 0, 0, 0, 0,
				 0, 0, 0, 0);
		break;
	case 5:
		SetBitsM(1, 0, 0, 0,
				 1, 1, 1, 0,
				 0, 0, 0, 0,
				 0, 0, 0, 0);
		break;
	case 6:
		SetBitsM(0, 0, 1, 0,
				 1, 1, 1, 0,
				 0, 0, 0, 0,
				 0, 0, 0, 0);
	}
	for (; i > 0; i--) RotateM(LEFT, FALSE);
	X=(short)(FIELD_WIDTH-WidthM())/2;
	Y=FIELD_HEIGHT-1;
	if (OverlapM(Matrix, X, Y)) DoDie();
}

void Full()
{
	X=Y=0;
	SetBitsM(0, 0, 0, 0,
			 0, 0, 0, 0,
			 0, 0, 0, 0,
			 0, 0, 0, 0);
	short x, y=0;
	for (; y<FIELD_HEIGHT; y++)
		for(x=0; x<FIELD_WIDTH; x++)
			Field[x][y]=1;
	if (IsWindow(hwndMain)) InvalidateRect(hwndMain, NULL, TRUE);
}

void New()
{
	X=Y=0;
	SetBitsM(0, 0, 0, 0,
			 0, 0, 0, 0,
			 0, 0, 0, 0,
			 0, 0, 0, 0);
	short x, y=0;
	for (; y<FIELD_HEIGHT; y++)
		for(x=0; x<FIELD_WIDTH; x++)
			Field[x][y]=0;
	ReSetM();
	InvalidateRect(hwndMain, NULL, TRUE);
}

void DrawBlock(short x, short y, HDC hdc)
{
	RECT Rect;
	x=x*m_side;
	y=(FIELD_HEIGHT - (y+1))*m_side;
	Rect.left = x;
	Rect.top = y;
	Rect.right = x+m_side;
	Rect.bottom = y+m_side;
	FillRect(hdc, &Rect, InBrush);
	MoveToEx(hdc, x, y, NULL);
	LineTo(hdc, x, y+m_side);
	LineTo(hdc, x+m_side, y+m_side);
	LineTo(hdc, x+m_side, y);
	LineTo(hdc, x, y);
}

void Draw(HDC hdc)
{
	short x, y=0;
	SelectObject(hdc, Border);
	for (; y<FIELD_HEIGHT; y++)
		for(x=0; x<FIELD_WIDTH; x++)
			if (Field[x][y]) DrawBlock(x, y, hdc);
	if (!IsZeroM(Matrix)) DrawM(hdc);
}

void DrawM(HDC hdc)
{
	char x, y=0;
	for (; y<4; y++)
		for(x=0; x<4; x++)
			if (Matrix[x][y]) DrawBlock(X+x, Y-y, hdc);
}

void ReDraw()
{
	if (!IsWindow(hwndMain)) return;
	RECT Rect;
	short i, j;
	static Block Fld[FIELD_WIDTH][FIELD_HEIGHT];
	for (i=0; i<FIELD_HEIGHT; i++)
		for (j=0; j<FIELD_WIDTH; j++)
			Fld[j][i]=Field[j][i];
	Incorp(Fld);
	for (i=0; i<FIELD_HEIGHT; i++)
		for (j=0; j<FIELD_WIDTH; j++)
			if (Fld[j][i] != OldField[j][i]) {
				DoRect(&Rect, j, i);
				InvalidateRect(hwndMain, &Rect, TRUE);
			}
}

void Copy()
{
	short i=0, j;
	for (; i<FIELD_HEIGHT; i++)
		for (j=0; j<FIELD_WIDTH; j++)
			OldField[j][i]=Field[j][i];
	Incorp(OldField);
}

void DoRect(RECT *Rect, short x, short y)
{
	x=x*m_side;
	y=(FIELD_HEIGHT - (y+1))*m_side;
	Rect->left = x-1;
	Rect->top = y-1;
	Rect->right = x+m_side+1;
	Rect->bottom = y+m_side+1;
}

void Fall()
{
	if (IsZeroM(Matrix)) return;
	Copy();
	for (; !OverlapM(Matrix, X, Y); Y--); Y++;
	Incorp(Field);
	ReDraw();
	DelRows();
	Copy();
	ReSetM();
	ReDraw();
}

void Incorp(Block Fld[FIELD_WIDTH][FIELD_HEIGHT])
{
	if (IsZeroM(Matrix)) return;
	short i=0, j;
	for (; i<4; i++)
		for (j=0; j<4; j++)
			if (Matrix[j][i] && Y-i>=0)
				Fld[X+j][Y-i] = Matrix[j][i];
}

void DelRows()
{
	short i, j, k;
	Copy();
	for (i=0; i<FIELD_HEIGHT; i++) {
		for (j=0; j<FIELD_WIDTH && Field[j][i]; j++);
		if (j==FIELD_WIDTH) {
			for (j=i; j<FIELD_HEIGHT-1; j++)
				for (k=0; k<FIELD_WIDTH; k++) Field[k][j]=Field[k][j+1];
			for (k=0; k<FIELD_WIDTH; k++) Field[k][j]=0;
			i--;
		}
	}
	ReDraw();
}

short WidthM()
{
	short max=0, i, j=0;
	for (;j<3;j++) {
		for (i=4; i>0 && !Matrix[i-1][j]; i--);
		max = i>max?i:max;
	}
	return max;
}

void MoveLeft()
{
	Copy();
	if (!OverlapM(Matrix, X-1, Y)) X--;
	ReDraw();
}

void MoveRight()
{
	Copy();
	if (!OverlapM(Matrix, X+1, Y)) X++;
	ReDraw();
}

void MoveDown()
{
	Copy();
	if (OverlapM(Matrix, X, Y-1)) { Fall(); return;}
	Y--;
	ReDraw();
}

void DoDie()
{
	if (nIDEv) {
		KillTimer(hwndMain, nIDEv);
		nIDEv=0;
	}
	Full();
}

BOOL OverlapM(Block NewMatrix[4][4], short x, short y)
{
	if (IsZeroM(NewMatrix)) return TRUE;
	short i, j;
	for (i=0; i<4; i++)
		for (j=0; j<4; j++) {
			if (NewMatrix[j][i]) {
				if (x+j<0 || x+j>=FIELD_WIDTH || y-i<0) return TRUE;
				if (Field[x+j][y-i]) return TRUE;
			}
		}
	return FALSE;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	HDC hdc;
	short i;
	switch (uMsg) {
		case WM_PAINT:
			hdc = BeginPaint(hwnd, &ps);
			SelectObject(hdc, GetStockObject(WHITE_PEN));
			for (i=1; i<FIELD_WIDTH; i++) {
				MoveToEx(hdc, i*m_side, 0, NULL);
				LineTo(hdc, i*m_side, rect.bottom);
			}
			Draw(hdc);
			EndPaint(hwnd, &ps); 
            return 0;
		case WM_CLOSE:
			PostQuitMessage(0);
			return 0;
		case WM_DESTROY:
			PostQuitMessage(0);
			return 0;
		case WM_KEYDOWN:
			if (wParam==VK_F2) {
				DoDie();
				New();
				nIDEv=SetTimer(hwndMain, rand(), 500, (TIMERPROC) TimerProc);
			}
			if (wParam==VK_LEFT && !Paused) MoveLeft();
			if (wParam==VK_RIGHT && !Paused) MoveRight();
			if (wParam==VK_DOWN && !Paused) MoveDown();
			if (wParam==VK_UP && !Paused) RotateM(RIGHT, TRUE);
			if (wParam==VK_CONTROL && !Paused) RotateM(LEFT, TRUE);
			if (wParam==VK_SPACE && !Paused) Fall();
			if (wParam==VK_ESCAPE) {
				if (!Paused && nIDEv) {
					Paused = TRUE;
					KillTimer(hwndMain, nIDEv);
					nIDEv = 0;
					return 0;
				}

				if (Paused && !nIDEv) {
					Paused = FALSE;
					nIDEv = SetTimer(hwndMain, rand() , 500, (TIMERPROC) TimerProc);
				}
			}
			return 0;
	}
	return DefWindowProc(hwnd, uMsg, wParam, lParam);
}

//TimerProc - The "Game/Play Loop"

VOID CALLBACK TimerProc(HWND hwnd, UINT uMsg, UINT idEvent, DWORD dwTime)
{
	MoveDown();
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	MSG msg;
	WNDCLASS wc;
	
	wc.style = CS_OWNDC;
	wc.lpfnWndProc = (WNDPROC) WndProc; 
    wc.cbClsExtra = 0;
	wc.cbWndExtra = 0; 
    wc.hInstance = hInstance;
	wc.hIcon = LoadIcon((HINSTANCE) NULL, IDI_WINLOGO);
	wc.hCursor = LoadCursor((HINSTANCE) NULL, IDC_ARROW);
	wc.hbrBackground = GetStockObject(BLACK_BRUSH); 
    wc.lpszMenuName = NULL; 
    wc.lpszClassName = "TetrIdiotWndClass";

	RegisterClass(&wc);
    
	hinst = hInstance;
    
	hwndMain = CreateWindow("TetrIdiotWndClass", "TetrIdiot", 
        WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX, CW_USEDEFAULT, CW_USEDEFAULT, 
        CW_USEDEFAULT, CW_USEDEFAULT, (HWND) NULL, 
        (HMENU) NULL, hinst, (LPVOID) NULL);

	//Setting size and position
	
	RECT deskrect, wndrect, clientrect;
	SIZE desksize, wndsize;
	POINT pt;
	GetWindowRect(GetDesktopWindow(), &deskrect);
	desksize.cy = deskrect.bottom - deskrect.top;
	desksize.cx = deskrect.right - deskrect.left;
	m_side = (short)((desksize.cy - 100) / FIELD_HEIGHT);
	GetWindowRect(hwndMain, &wndrect);
	GetClientRect(hwndMain, &clientrect);
	pt.x = clientrect.left;
	pt.y = clientrect.top;
	ClientToScreen(hwndMain, &pt);
	clientrect.left = pt.x;
	clientrect.top = pt.y;
	pt.x = clientrect.right;
	pt.y = clientrect.bottom;
	ClientToScreen(hwndMain, &pt);
	clientrect.right = pt.x;
	clientrect.bottom = pt.y;
	wndsize.cx = (clientrect.left - wndrect.left) + (wndrect.right - clientrect.right) + FIELD_WIDTH * m_side;
	wndsize.cy = (clientrect.top - wndrect.top) + (wndrect.bottom - clientrect.bottom) + FIELD_HEIGHT * m_side;
	SetWindowPos(hwndMain, HWND_TOP, (desksize.cx-wndsize.cx)/2, (desksize.cy-wndsize.cy)/2, wndsize.cx, wndsize.cy, NULL);
	GetClientRect(hwndMain, &rect);
	nIDEv=0;
	Paused=FALSE;
	srand((unsigned)time(NULL));

	Full();
	InBrush = CreateSolidBrush(RECTCOLOR);
	Border = CreatePen(PS_SOLID, 0, RECTBORDER);
    
	ShowWindow(hwndMain, nCmdShow);
	UpdateWindow(hwndMain);  
    
	while (GetMessage(&msg, (HWND) NULL, 0, 0)) 
    {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}  
    return msg.wParam;
}